
c========================================================================
      SUBROUTINE DATA_READ(mean_e_all,mean_e_low,mean_e_mid,mean_e_high,
     >                      std_e_all, std_e_low, std_e_mid, std_e_high,
     >                     five_e_all,five_e_low,five_e_mid,five_e_high,
     >                 tfive_e_all,tfive_e_low,tfive_e_mid,tfive_e_high,
     >                      med_e_all, med_e_low, med_e_mid, med_e_high,
     >                 sfive_e_all,sfive_e_low,sfive_e_mid,sfive_e_high,
     >                 nfive_e_all,nfive_e_low,nfive_e_mid,nfive_e_high,
     >                     mean_i_all,mean_i_low,mean_i_mid,mean_i_high,
     >                      std_i_all, std_i_low, std_i_mid, std_i_high,
     >                     five_i_all,five_i_low,five_i_mid,five_i_high,
     >                 tfive_i_all,tfive_i_low,tfive_i_mid,tfive_i_high,
     >                      med_i_all, med_i_low, med_i_mid, med_i_high,
     >                 sfive_i_all,sfive_i_low,sfive_i_mid,sfive_i_high,
     >                 nfive_i_all,nfive_i_low,nfive_i_mid,nfive_i_high)
c========================================================================
c  data_read.f
c  Read in averaged MPA data from ascii text files.

      IMPLICIT NONE

c     DEFINE INTEGER VARIABLES
      INTEGER(KIND=8) KPS, ENS, LTS, VALS
      INTEGER(KIND=8) I, J, K

c     DEFINE PARAMETERS
      PARAMETER(KPS=28, ENS=40, LTS=24, VALS=7)

c     DEFINE REAL ARRAYS
      REAL(KIND=8) mean_e_all(KPS,ENS,LTS)
      REAL(KIND=8) std_e_all(KPS,ENS,LTS)
      REAL(KIND=8) five_e_all(KPS,ENS,LTS)
      REAL(KIND=8) tfive_e_all(KPS,ENS,LTS)
      REAL(KIND=8) med_e_all(KPS,ENS,LTS)
      REAL(KIND=8) sfive_e_all(KPS,ENS,LTS)
      REAL(KIND=8) nfive_e_all(KPS,ENS,LTS)

      REAL(KIND=8) mean_e_low(KPS,ENS,LTS)
      REAL(KIND=8) std_e_low(KPS,ENS,LTS)
      REAL(KIND=8) five_e_low(KPS,ENS,LTS)
      REAL(KIND=8) tfive_e_low(KPS,ENS,LTS)
      REAL(KIND=8) med_e_low(KPS,ENS,LTS)
      REAL(KIND=8) sfive_e_low(KPS,ENS,LTS)
      REAL(KIND=8) nfive_e_low(KPS,ENS,LTS)

      REAL(KIND=8) mean_e_mid(KPS,ENS,LTS)
      REAL(KIND=8) std_e_mid(KPS,ENS,LTS)
      REAL(KIND=8) five_e_mid(KPS,ENS,LTS)
      REAL(KIND=8) tfive_e_mid(KPS,ENS,LTS)
      REAL(KIND=8) med_e_mid(KPS,ENS,LTS)
      REAL(KIND=8) sfive_e_mid(KPS,ENS,LTS)
      REAL(KIND=8) nfive_e_mid(KPS,ENS,LTS)

      REAL(KIND=8) mean_e_high(KPS,ENS,LTS)
      REAL(KIND=8) std_e_high(KPS,ENS,LTS)
      REAL(KIND=8) five_e_high(KPS,ENS,LTS)
      REAL(KIND=8) tfive_e_high(KPS,ENS,LTS)
      REAL(KIND=8) med_e_high(KPS,ENS,LTS)
      REAL(KIND=8) sfive_e_high(KPS,ENS,LTS)
      REAL(KIND=8) nfive_e_high(KPS,ENS,LTS)

      REAL(KIND=8) mean_i_all(KPS,ENS,LTS)
      REAL(KIND=8) std_i_all(KPS,ENS,LTS)
      REAL(KIND=8) five_i_all(KPS,ENS,LTS)
      REAL(KIND=8) tfive_i_all(KPS,ENS,LTS)
      REAL(KIND=8) med_i_all(KPS,ENS,LTS)
      REAL(KIND=8) sfive_i_all(KPS,ENS,LTS)
      REAL(KIND=8) nfive_i_all(KPS,ENS,LTS)

      REAL(KIND=8) mean_i_low(KPS,ENS,LTS)
      REAL(KIND=8) std_i_low(KPS,ENS,LTS)
      REAL(KIND=8) five_i_low(KPS,ENS,LTS)
      REAL(KIND=8) tfive_i_low(KPS,ENS,LTS)
      REAL(KIND=8) med_i_low(KPS,ENS,LTS)
      REAL(KIND=8) sfive_i_low(KPS,ENS,LTS)
      REAL(KIND=8) nfive_i_low(KPS,ENS,LTS)

      REAL(KIND=8) mean_i_mid(KPS,ENS,LTS)
      REAL(KIND=8) std_i_mid(KPS,ENS,LTS)
      REAL(KIND=8) five_i_mid(KPS,ENS,LTS)
      REAL(KIND=8) tfive_i_mid(KPS,ENS,LTS)
      REAL(KIND=8) med_i_mid(KPS,ENS,LTS)
      REAL(KIND=8) sfive_i_mid(KPS,ENS,LTS)
      REAL(KIND=8) nfive_i_mid(KPS,ENS,LTS)

      REAL(KIND=8) mean_i_high(KPS,ENS,LTS)
      REAL(KIND=8) std_i_high(KPS,ENS,LTS)
      REAL(KIND=8) five_i_high(KPS,ENS,LTS)
      REAL(KIND=8) tfive_i_high(KPS,ENS,LTS)
      REAL(KIND=8) med_i_high(KPS,ENS,LTS)
      REAL(KIND=8) sfive_i_high(KPS,ENS,LTS)
      REAL(KIND=8) nfive_i_high(KPS,ENS,LTS)

      REAL(KIND=8) en_he,en_hp,log_en_he,log_en_hp

c     DEFINE CHARACTER VARIABLES
      CHARACTER*100 DUMMY_TXT
      CHARACTER*100 e_file_all
      CHARACTER*100 i_file_all

      CHARACTER*100 e_file_low
      CHARACTER*100 i_file_low

      CHARACTER*100 e_file_mid
      CHARACTER*100 i_file_mid

      CHARACTER*100 e_file_high
      CHARACTER*100 i_file_high

      e_file_all='data/model_e_array_all.txt'
      i_file_all='data/model_i_array_all.txt'

      e_file_low='data/model_e_array_low.txt'
      i_file_low='data/model_i_array_low.txt'

      e_file_mid='data/model_e_array_mid.txt'
      i_file_mid='data/model_i_array_mid.txt'

      e_file_high='data/model_e_array_high.txt'
      i_file_high='data/model_i_array_high.txt'

c     ARRAYS ARE OF THE FORM array(28, 40, 24)
c     28 VALUES OF KP
c     40 ENERGIES DEFINED IN en_he and en_hp
c     24 LOCAL TIMES from 0 to 23.

      WRITE(6,*) 'READING DATA...'

c     ==========================ALL F10.7================================

c     READ IN ELECTRON FLUXES (ALL F10.7)
      OPEN(UNIT=21, FILE=e_file_all, STATUS='OLD')
      READ(21,'(A)') DUMMY_TXT
      DO 25 I=1,KPS
        DO 10 J=1,ENS
          READ(21,200) (mean_e_all(I,J,K),K=1,24)
 10     CONTINUE    
        DO 12 J=1,ENS
          READ(21,200) (std_e_all(I,J,K),K=1,24)
 12     CONTINUE
        DO 14 J=1,ENS
          READ(21,200) (five_e_all(I,J,K),K=1,24)
 14     CONTINUE    
        DO 16 J=1,ENS
          READ(21,200) (tfive_e_all(I,J,K),K=1,24)
 16     CONTINUE
        DO 18 J=1,ENS
          READ(21,200) (med_e_all(I,J,K),K=1,24)
 18     CONTINUE
        DO 20 J=1,ENS
          READ(21,200) (sfive_e_all(I,J,K),K=1,24)
 20     CONTINUE
        DO 22 J=1,ENS
          READ(21,200) (nfive_e_all(I,J,K),K=1,24)
 22     CONTINUE    
 25   CONTINUE
      CLOSE(UNIT=21)

c     READ IN ION FLUXES (ALL F10.7)
      OPEN(UNIT=22, FILE=i_file_all, STATUS='OLD')
      READ(22,'(A)') DUMMY_TXT
      DO 45 I=1,KPS
        DO 30 J=1,ENS
          READ(22,200) (mean_i_all(I,J,K),K=1,24)
 30     CONTINUE    
        DO 32 J=1,ENS
          READ(22,200) (std_i_all(I,J,K),K=1,24)
 32     CONTINUE    
        DO 34 J=1,ENS
          READ(22,200) (five_i_all(I,J,K),K=1,24)
 34    CONTINUE    
        DO 36 J=1,ENS
          READ(22,200) (tfive_i_all(I,J,K),K=1,24)
 36     CONTINUE    
        DO 38 J=1,ENS
          READ(22,200) (med_i_all(I,J,K),K=1,24)
 38    CONTINUE    
        DO 40 J=1,ENS
          READ(22,200) (sfive_i_all(I,J,K),K=1,24)
 40    CONTINUE    
        DO 42 J=1,ENS
          READ(22,200) (nfive_i_all(I,J,K),K=1,24)
 42    CONTINUE    
 45   CONTINUE
      CLOSE(UNIT=22)

c     ==========================LOW F10.7================================

c     READ IN ELECTRON FLUXES (F10.7 < 100)
      OPEN(UNIT=23, FILE=e_file_low, STATUS='OLD')
      READ(23,'(A)') DUMMY_TXT
      DO 65 I=1,KPS
        DO 50 J=1,ENS
          READ(23,200) (mean_e_low(I,J,K),K=1,24)
 50     CONTINUE    
        DO 52 J=1,ENS
          READ(23,200) (std_e_low(I,J,K),K=1,24)
 52     CONTINUE    
        DO 54 J=1,ENS
          READ(23,200) (five_e_low(I,J,K),K=1,24)
 54     CONTINUE    
        DO 56 J=1,ENS
          READ(23,200) (tfive_e_low(I,J,K),K=1,24)
 56     CONTINUE    
        DO 58 J=1,ENS
          READ(23,200) (med_e_low(I,J,K),K=1,24)
 58     CONTINUE    
        DO 60 J=1,ENS
          READ(23,200) (sfive_e_low(I,J,K),K=1,24)
 60     CONTINUE    
        DO 62 J=1,ENS
          READ(23,200) (nfive_e_low(I,J,K),K=1,24)
 62     CONTINUE    
 65   CONTINUE
      CLOSE(UNIT=23)

c     READ IN ION FLUXES (F10,7 < 100)
      OPEN(UNIT=24, FILE=i_file_low, STATUS='OLD')
      READ(24,'(A)') DUMMY_TXT
      DO 85 I=1,KPS
        DO 70 J=1,ENS
          READ(24,200) (mean_i_low(I,J,K),K=1,24)
 70     CONTINUE    
        DO 72 J=1,ENS
          READ(24,200) (std_i_low(I,J,K),K=1,24)
 72     CONTINUE    
        DO 74 J=1,ENS
          READ(24,200) (five_i_low(I,J,K),K=1,24)
 74     CONTINUE    
        DO 76 J=1,ENS
          READ(24,200) (tfive_i_low(I,J,K),K=1,24)
 76     CONTINUE    
        DO 78 J=1,ENS
          READ(24,200) (med_i_low(I,J,K),K=1,24)
 78     CONTINUE    
        DO 80 J=1,ENS
          READ(24,200) (sfive_i_low(I,J,K),K=1,24)
 80     CONTINUE    
        DO 82 J=1,ENS
          READ(24,200) (nfive_i_low(I,J,K),K=1,24)
 82     CONTINUE    
 85   CONTINUE
      CLOSE(UNIT=24)

c     ==========================MID F10.7================================

c     READ IN ELECTRON FLUXES (100 <= F10.7 < 170)
      OPEN(UNIT=25, FILE=e_file_mid, STATUS='OLD')
      READ(25,'(A)') DUMMY_TXT
      DO 105 I=1,KPS
        DO 90 J=1,ENS
          READ(25,200) (mean_e_mid(I,J,K),K=1,24)
 90     CONTINUE    
        DO 92 J=1,ENS
          READ(25,200) (std_e_mid(I,J,K),K=1,24)
 92     CONTINUE    
        DO 94 J=1,ENS
          READ(25,200) (five_e_mid(I,J,K),K=1,24)
 94     CONTINUE    
        DO 96 J=1,ENS
          READ(25,200) (tfive_e_mid(I,J,K),K=1,24)
 96     CONTINUE    
        DO 98 J=1,ENS
          READ(25,200) (med_e_mid(I,J,K),K=1,24)
 98     CONTINUE    
        DO 100 J=1,ENS
          READ(25,200) (sfive_e_mid(I,J,K),K=1,24)
 100    CONTINUE    
        DO 102 J=1,ENS
          READ(25,200) (nfive_e_mid(I,J,K),K=1,24)
 102    CONTINUE    
 105  CONTINUE
      CLOSE(UNIT=25)

c     READ IN ION FLUXES (100 <= F10.7 < 170)
      OPEN(UNIT=26, FILE=i_file_mid, STATUS='OLD')
      READ(26,'(A)') DUMMY_TXT
      DO 125 I=1,KPS
        DO 110 J=1,ENS
          READ(26,200) (mean_i_mid(I,J,K),K=1,24)
 110    CONTINUE    
        DO 112 J=1,ENS
          READ(26,200) (std_i_mid(I,J,K),K=1,24)
 112    CONTINUE    
        DO 114 J=1,ENS
          READ(26,200) (five_i_mid(I,J,K),K=1,24)
 114    CONTINUE    
        DO 116 J=1,ENS
          READ(26,200) (tfive_i_mid(I,J,K),K=1,24)
 116    CONTINUE    
        DO 118 J=1,ENS
          READ(26,200) (med_i_mid(I,J,K),K=1,24)
 118    CONTINUE    
        DO 120 J=1,ENS
          READ(26,200) (sfive_i_mid(I,J,K),K=1,24)
 120    CONTINUE    
        DO 122 J=1,ENS
          READ(26,200) (nfive_i_mid(I,J,K),K=1,24)
 122    CONTINUE    
 125  CONTINUE
      CLOSE(UNIT=26)

c     ==========================HIGH F10.7===============================

c     READ IN ELECTRON FLUXES (F10.7 >= 170)
      OPEN(UNIT=27, FILE=e_file_high, STATUS='OLD')
      READ(27,'(A)') DUMMY_TXT
      DO 145 I=1,KPS
        DO 130 J=1,ENS
          READ(27,200) (mean_e_high(I,J,K),K=1,24)
 130    CONTINUE    
        DO 132 J=1,ENS
          READ(27,200) (std_e_high(I,J,K),K=1,24)
 132    CONTINUE    
        DO 134 J=1,ENS
          READ(27,200) (five_e_high(I,J,K),K=1,24)
 134    CONTINUE    
        DO 136 J=1,ENS
          READ(27,200) (tfive_e_high(I,J,K),K=1,24)
 136    CONTINUE    
        DO 138 J=1,ENS
          READ(27,200) (med_e_high(I,J,K),K=1,24)
 138    CONTINUE    
        DO 140 J=1,ENS
          READ(27,200) (sfive_e_high(I,J,K),K=1,24)
 140    CONTINUE    
        DO 142 J=1,ENS
          READ(27,200) (nfive_e_high(I,J,K),K=1,24)
 142    CONTINUE    
 145  CONTINUE
      CLOSE(UNIT=27)

c     READ IN ION FLUXES  (F10.7 >= 170)
      OPEN(UNIT=28, FILE=i_file_high, STATUS='OLD')
      READ(28,'(A)') DUMMY_TXT
      DO 165 I=1,KPS
        DO 150 J=1,ENS
          READ(28,200) (mean_i_high(I,J,K),K=1,24)
 150    CONTINUE    
        DO 152 J=1,ENS
          READ(28,200) (std_i_high(I,J,K),K=1,24)
 152    CONTINUE    
        DO 154 J=1,ENS
          READ(28,200) (five_i_high(I,J,K),K=1,24)
 154    CONTINUE    
        DO 156 J=1,ENS
          READ(28,200) (tfive_i_high(I,J,K),K=1,24)
 156    CONTINUE    
        DO 158 J=1,ENS
          READ(28,200) (med_i_high(I,J,K),K=1,24)
 158    CONTINUE    
        DO 160 J=1,ENS
          READ(28,200) (sfive_i_high(I,J,K),K=1,24)
 160    CONTINUE    
        DO 162 J=1,ENS
          READ(28,200) (nfive_i_high(I,J,K),K=1,24)
 162    CONTINUE    
 165  CONTINUE
      CLOSE(UNIT=28)

 200  FORMAT(24E18.6)
 201  FORMAT(I6, I6, 2D18.6)

      WRITE(6,*) 'FLUX DATA READ IN COMPLETE!'

      RETURN

      END
c===================END SUBROUTINE DATA_READ=============================
